searchNodes=[{"ref":"Tarearbol.html","title":"Tarearbol","type":"module","doc":"Tarearbol module provides an interface to run tasks in easy way. Examples iex&gt; result = Tarearbol.ensure(fn -&gt; raise &quot;¡?&quot; end, attempts: 1, raise: false) iex&gt; {:error, %{job: _job, outcome: outcome}} = result iex&gt; {error, _stacktrace} = outcome iex&gt; error %RuntimeError{message: &quot;¡?&quot;}"},{"ref":"Tarearbol.html#drain/1","title":"Tarearbol.drain/1","type":"function","doc":"Executes all the scheduled tasks immediately, cleaning up the queue."},{"ref":"Tarearbol.html#ensure/2","title":"Tarearbol.ensure/2","type":"function","doc":"Ensures the task to be completed; restarts it when necessary. Possible options: attempts [default: :infinity] Might be any of @Tarearbol.Utils.interval type (5 for five attempts, :random for the random amount etc) delay [default: 1 msec]. Might be any of @Tarearbol.Utils.interval type (1_000 or 1.0 for one second, :timeout for five seconds etc) on_success [default: nil], the function to be called on successful execution (arity ∈ [0, 1] or tuple {Mod, fun} where fun is of arity zero or one.) When the arity of given function is 1, the result of task execution is passed on_retry [default: nil], same as above, called on retries after insuccessful attempts or one of [:debug, :info, :warn, :error] atoms to log a retry with default logger on_fail [default: nil], same as above, called when the task finally failed after attempts amount of insuccessful attempts"},{"ref":"Tarearbol.html#ensure!/2","title":"Tarearbol.ensure!/2","type":"function","doc":"Same as Tarearbol.ensure/2, but it raises on fail and returns the result itself on successful execution."},{"ref":"Tarearbol.html#ensure_all/2","title":"Tarearbol.ensure_all/2","type":"function","doc":"Executes Tarearbol.ensure_all_streamed/2 and collects tasks results."},{"ref":"Tarearbol.html#ensure_all_streamed/2","title":"Tarearbol.ensure_all_streamed/2","type":"function","doc":"Wrapper for Task.Supervisor.async_stream/4."},{"ref":"Tarearbol.html#run_at/3","title":"Tarearbol.run_at/3","type":"function","doc":"Runs a task specified by the first argument at a given time. If the second parameter is a [DateTime] struct, the task will be run once. If the second parameter is a [Time] struct, the task will be run at that time on daily basis."},{"ref":"Tarearbol.html#run_in/3","title":"Tarearbol.run_in/3","type":"function","doc":"Runs a task specified by the first argument in a given interval. See [Tarearbol.ensure/2] for all possible variants of the interval argument."},{"ref":"Tarearbol.html#spawn/2","title":"Tarearbol.spawn/2","type":"function","doc":"Spawns the task for the immediate async execution."},{"ref":"Tarearbol.html#spawn_ensured/2","title":"Tarearbol.spawn_ensured/2","type":"function","doc":"Spawns an ensured job asynchronously, passing all options given."},{"ref":"Tarearbol.DynamicManager.html","title":"Tarearbol.DynamicManager","type":"behaviour","doc":"The scaffold implementation to dynamically manage many similar tasks running as processes. It creates a main supervisor, managing the GenServer holding the state and DynamicSupervisor handling chidren. It has a strategy :rest_for_one, assuming that if the process holding the state crashes, the children will be restarted. Typically one calls use Tarearbol.DynamicManager and implements at least children_specs/0 callback and receives back supervised tree with a state and many processes controlled by DynamicSupervisor. To see how it works you might try defmodule DynamicManager do use Tarearbol.DynamicManager def children_specs do for i &lt;- 1..10, do: {&quot;foo_\#{i}&quot;, []}, into: %{} end end {:ok, pid} = DynamicManager.start_link() The above would spawn 10 children with IDs &quot;foo1&quot;..&quot;foo10&quot;. DynamicManager also allows dynamic workers management. It exports three functions @spec put(id :: binary(), opts :: Enum.t()) :: pid() @spec del(id :: binary()) :: :ok @spec get(id :: binary()) :: Enum.t() The semantics of put/2 arguments is the same as a single child_spec, del/1 and get/1 receive the unique ID of the child and shutdown it or return it’s payload respectively."},{"ref":"Tarearbol.DynamicManager.html#c:children_specs/0","title":"Tarearbol.DynamicManager.children_specs/0","type":"callback","doc":"This function is called to retrieve the map of children with name as key and a workers as the value. The value must be an enumerable with keys among: :payload (passed as second argument to perform/2, default nil) :timeout (time between iterations of perform/2, default 1 second) :lull (threshold to notify latency in performing, default 1.1 (the threshold is :lull times the :timeout)) This function should not care about anything save for producing side effects. It will be backed by DynamicSupervisor. The value it returns will be put into the state under children key."},{"ref":"Tarearbol.DynamicManager.html#c:handle_state_change/1","title":"Tarearbol.DynamicManager.handle_state_change/1","type":"callback","doc":"Declares an instance-wide callback to report state; if the startup process takes a while, it’d be run in handle_continue/2 and this function will be called after it finishes so that the application might start using it. If the application is not interested in receiving state updates, e. g. when all it needs from runners is a side effect, there is a default implementation that does nothing."},{"ref":"Tarearbol.DynamicManager.html#c:handle_timeout/1","title":"Tarearbol.DynamicManager.handle_timeout/1","type":"callback","doc":"Declares a callback to report slow process (when the scheduler cannot process in a reasonable time)."},{"ref":"Tarearbol.DynamicManager.html#c:perform/2","title":"Tarearbol.DynamicManager.perform/2","type":"callback","doc":"The main function, doing all the job, supervised. It will be called with the child id as first argument and the payload option to child spec as second argument (defaulting to nil, can also be ignored if not needed). perform/2 must return :halt if it wants to be killed or anything else to be treated as a result."},{"ref":"Tarearbol.TaskFailedError.html","title":"Tarearbol.TaskFailedError","type":"exception","doc":""},{"ref":"intro.html","title":"Tarearbol","type":"extras","doc":"Tarearbol Lightweight task manager, allowing retries, callbacks, assurance that the task succeeded, and more Scaffold for managing many children under a DynamicSupervisor with a pleasure"},{"ref":"intro.html#task-management","title":"Tarearbol - Task Management","type":"extras","doc":"Features Task supervision tree for granted Infinite retries until succeeded Async execution of a single task with retries Async execution of many tasks with retries Limited amount of retries Delay between retries Callbacks on on_retry, on_success, on_fail Configurable “success” treatment Task scheduling and draining, cron-like execution Task Management Examples"},{"ref":"intro.html#dynamic-workers-management","title":"Tarearbol - Dynamic Workers Management","type":"extras","doc":"Features Scaffold for the supervised DynamicSupervisor No code for managing processes required Implementation is as easy as 4 callbacks Behaviour-driven consumers Consistent state and callbacks on state changes (like restarting) Dynamic Workers Management Examples"},{"ref":"task_management.html","title":"Task Management","type":"extras","doc":"Task Management"},{"ref":"task_management.html#task-supervision-tree-for-granted","title":"Task Management - Task supervision tree for granted","type":"extras","doc":"Add :tarearbol to the list of applications and you are all set."},{"ref":"task_management.html#infinite-retries","title":"Task Management - Infinite retries","type":"extras","doc":"Tarearbol.ensure fn -&gt; unless Enum.random(1..100) == 42, do: raise &quot;Incorrect answer&quot; {:ok, 42} end # some bad-case logging {:ok, 42}"},{"ref":"task_management.html#async-execution-with-retries","title":"Task Management - Async execution with retries","type":"extras","doc":"Tarearbol.spawn_ensured({Process, :sleep, [1_000]}, attempts: 1, on_success: {IO, :inspect, [[label: &quot;Result&quot;]]}) %Task{ owner: #PID&lt;0.248.0&gt;, pid: #PID&lt;0.271.0&gt;, ref: #Reference&lt;0.1612468028.2321547270.14001&gt; } # &lt;one second delay&gt; Result: :ok"},{"ref":"task_management.html#async-execution-of-many-tasks-with-retries","title":"Task Management - Async execution of many tasks with retries","type":"extras","doc":"res = 1..20 |&gt; Enum.map(fn i -&gt; fn -&gt; Process.sleep(Enum.random(1..i)); i end end) |&gt; Tarearbol.Job.ensure_all(attempts: 1) [{:ok, 1}, {:ok, 2}, ..., {:ok, 20}] NB the above is synchronized against main process."},{"ref":"task_management.html#limited-amount-of-retries","title":"Task Management - Limited amount of retries","type":"extras","doc":"Tarearbol.ensure fn -&gt; raise &quot;Incorrect answer&quot; end, attempts: 10 # some bad-case logging {:error, %{job: #Function&lt;20.87737649/0 in :erl_eval.expr/5&gt;, outcome: {%RuntimeError{message: &quot;Incorrect answer&quot;}, [{:erl_eval, :do_apply, 6, [file: &#39;erl_eval.erl&#39;, line: 668]}, {Task.Supervised, :do_apply, 2, [file: &#39;lib/task/supervised.ex&#39;, line: 85]}, {Task.Supervised, :reply, 5, [file: &#39;lib/task/supervised.ex&#39;, line: 36]}, {:proc_lib, :init_p_do_apply, 3, [file: &#39;proc_lib.erl&#39;, line: 247]}]}}}"},{"ref":"task_management.html#delay-between-retries","title":"Task Management - Delay between retries","type":"extras","doc":"Tarearbol.ensure fn -&gt; unless Enum.random(1..100) == 42, do: raise &quot;Incorrect answer&quot; {:ok, 42} end, delay: 1000 # some slow bad-case logging {:ok, 42}"},{"ref":"task_management.html#callbacks","title":"Task Management - Callbacks","type":"extras","doc":"Tarearbol.ensure fn -&gt; unless Enum.random(1..100) == 42, do: raise &quot;Incorrect answer&quot; {:ok, 42} end, on_success: fn data -&gt; IO.inspect(data, label: &quot;★&quot;) end, on_retry: {IO, :inspect, [[label: &quot;☆&quot;]]} end # some slow bad-case logging # ⇓⇓⇓⇓ one or more of ⇓⇓⇓⇓ ☆: %{cause: :on_raise, data: {%RuntimeError{message: &quot;Incorrect answer&quot;}, [{:erl_eval, :do_apply, 6, [file: &#39;erl_eval.erl&#39;, line: 670]}, {:erl_eval, :exprs, 5, [file: &#39;erl_eval.erl&#39;, line: 122]}, {Task.Supervised, :do_apply, 2, [file: &#39;lib/task/supervised.ex&#39;, line: 85]}, {Task.Supervised, :reply, 5, [file: &#39;lib/task/supervised.ex&#39;, line: 36]}, {:proc_lib, :init_p_do_apply, 3, [file: &#39;proc_lib.erl&#39;, line: 247]}]}} # ⇑⇑⇑⇑ one or more of ⇑⇑⇑⇑ ★: 42 {:ok, 42}"},{"ref":"task_management.html#allowed-options","title":"Task Management - Allowed options","type":"extras","doc":"attempts integer, an amount of attempts before giving up, 0 for forever; default: :infinity delay the delay between attempts, default: :none; - raise: when true, will raise after all attempts were unsuccessful, or return {:error, outcome} tuple otherwise, default: false; accept_not_ok: when true, any result save for {:error, _} will be accepted as correct, otherwise only {:ok, _} is treated as correct, default: true; on_success: callback when the task returned a result, default: nil; on_retry: callback when the task failed and scheduled for retry, default: :debug; on_fail: callback when the task completely failed, default: :warn. for :attempts and :delay keys one might specify the following values: integer → amount to be used as is (milliseconds for delay, number for attempts); float → amount of thousands, rounded (seconds for delay, thousands for attempts); :none → 0; :tiny → 10; :medium → 100; :infinity → -1, :attempts only."},{"ref":"task_management.html#task-spawning","title":"Task Management - Task spawning","type":"extras","doc":"Tarearbol.run_in fn -&gt; IO.puts(42) end, 1_000 # 1 sec Tarearbol.spawn fn -&gt; IO.puts(42) end # immediately"},{"ref":"task_management.html#task-draining","title":"Task Management - Task draining","type":"extras","doc":"Tarearbol.run_in fn -&gt; IO.inspect(42) end, 1_000 # 1 sec Tarearbol.run_in fn -&gt; IO.inspect(:foo) end, 1_000 # 1 sec Tarearbol.drain 42 # immediately, from `IO.inspect` :foo # immediately, from `IO.inspect` [ok: 42, ok: :foo] # immediately, the returned value(s)"},{"ref":"dynamic_workers_management.html","title":"Dynamic Workers Management","type":"extras","doc":"Dynamic Workers Management DynamicSupervisor is a very handy tool to manage many different task-like processes. It is used mostly when one does not know in advance how many processes are to be run, and the processes happen to appear based on some external conditions. A good example would be a web scraper; we might spawn a process per every new page we need to crawl and DynamicSupervisor would take care about restarting those failed. It might become slightly cumbersome for the projects requiring more-or-less same behaviour but when the supervised processes should perform some periodical job, maybe exit upon job outcome and be accessible by some id while they are running. For the contrived example, imagine the main dashboard that displays the state of all the computers, connected to the intranet. There are guests with notebooks, constantly connecting and disconneting. Let’s say we want to maintain a list of processes spying on our guests (please do not use this library that way, though.) We need to be able to query the processes for current state / stats by computer ID, say, MAC-address. The first wild guess would be to convert MACs to alphanumeric and then to atoms to give names to our workers. And then call them by name. This approach is not only naïve but also very dangerous. That way we’d DOS our ErlangVM with atoms. So yeah, the dictionary MAC → PID is to be stored somewhere else. So we already need to have a supervisor, managing the state and DynamicSupervisor, which in turn manages workers. Also, upon startup there is a warming period during which we probably do not want to show anything since the data might be inaccurate. This warming stage should be probably done from inside handle_continue/2 from some another process, and this process cannot be the state one due to restart strategy :rest_for_one, which is required to restart workers when the state has crashed. All the problems above are very similar for this kind of task. So, welcome DynamicSupervisor which solves all the problems above automagically, leaving the consumer with a pure business logic implementation. The only needed thing to make it all up and running would be to implement Tarearbol.DynamicManager behaviour. It consists of four functions. children_specs/0 @callback children_specs :: %{required(binary()) =&gt; Enum.t()} Return value should be a map of id → settings where id is the unique identifier of the process and possible settings values are described in the documentation. perform/2 @callback perform(id :: binary(), payload :: term()) :: any() The implementation of the worker. This function will be called with the child id as first argument and the payload option to child spec as second argument. If it returns :halt, the process is considered done his job. Any other outcome will be treated as as a result and stored in the State. handle_state_change/1 @callback handle_state_change(state :: :down | :up | :starting | :unknown) :: :ok | :restart This callback will be called on state changes, like :starting while the initial state is not yet fully loaded and :started upon readyness. handle_timeout/1 @callback handle_timeout(state :: map()) :: any() This callback will be called if the worker cannot process in a reasonable time."}]